

const unsigned char SharpASCII [ 49 ] = {  
    '_',' ','e',' ','~',' ','t','g',
    'h',' ','b','x','d','r','p','c',
    'q','a','z','w','s','u','i',' ',
    ' ','k','f','v',' ',' ',' ','j',
    'n',' ',' ','m',' ',' ',' ','o',
    'l',' ',' ',' ',' ','y','{',' ',
    '|' };

unsigned char FromSHASCII ( unsigned char c ) {
    if ( c <= 0x5d ) return ( c );
    if ( c == 0x80 ) return ( '}' );
    if ( c < 0x90 || c > 0xc0 ) return ( ' ' );
    return ( SharpASCII [ c - 0x90 ] );
}

unsigned char ToSHASCII ( unsigned char c ) {
    unsigned char i;
    
    if ( c <= 0x5d ) return ( c );
    if ( c == '}' ) return ( 0x80 );
    for ( i = 0; i < sizeof ( SharpASCII ); i++ ) {
        if ( c == SharpASCII [ i ] ) {
            return ( i + 0x90 );
        };
    }
    return ( ' ' );
}

#if 0
void MZROM_clrs ( void ) __naked {
    __asm
    push af
    call 0xEA59
    pop af
    ret
    __endasm;
}

void MZROM_msg ( char *msg ) __naked { 
    __asm
    push ix
    push de  
    ld ix,#0 
    add ix,sp
    ld e,6(ix)
    ld d,7(ix)
    call 0x0015
    pop de
    pop ix
    ret
    __endasm;
}
#endif

void MZROM_prntc ( char c ) __naked {
    __asm
    push ix
    push de
    push af  
    ld ix,#0 
    add ix,sp
    ld d,8(ix)
    ld a,d    
    call 0x0012
    pop af
    pop de
    pop ix
    ret
    __endasm;    
}

void MZROM_dpct ( char c ) __naked {
    __asm
    push ix
    push de
    push af  
    ld ix,#0 
    add ix,sp
    ld d,8(ix)
    ld a,d    
    call 0x0ddc
    pop af
    pop de
    pop ix
    ret
    __endasm;    
}

void xputc ( unsigned char c ) {
    if ( c == '\n' ) {
        MZROM_dpct ( 0xcd );
    } else {
        MZROM_prntc ( ToSHASCII ( c ) );
    };
}

void xputs ( unsigned char *str ) {
    while ( *str ) {
        xputc ( *str++ );
    };
}


void xsleep ( unsigned char wsec ) {
    unsigned int i;
    
    if ( ! wsec ) return;
    
    while ( wsec-- ) {
        i=0xffff;
        while (i--) {};
    };
}
