
#include "xmodem.h"

__sfr __banked __at	0x06cf	rBCOL;

__sfr __at 		0xce 	rDMD;

// porty k mapovani standardni pameti
__sfr __at 		0xe0 	rMAPE0;
__sfr __at 		0xe1 	rMAPE1;
__sfr __at 		0xe2 	rMAPE2;
__sfr __at 		0xe3 	rMAPE3;
__sfr __at 		0xe4 	rMAPE4;
__sfr __at 		0xe5 	rMAPE5;
__sfr __at 		0xe6 	rMAPE6;


// unicard
__sfr __at 		0x50 	rUCMD;
__sfr __at 		0x51 	rUDATA;

// SIO
__sfr __at 		0x52 	rSIO0;
__sfr __at 		0x53 	rSIO1;


/*
 * Presunout MZF header, namapovat ROM a JP 0xECFC.
 *
 */
void StartUpPrg ( void ) __naked {
    __asm
        ld hl,#0x1180
        ld de,#0x10f0
        ld bc,#0x0080
        ldir
        ld hl,#1$
        ld de,#0x1000
        ld bc,#(2$-1$)
        ldir
        jp 0x1000
    1$:
        out (#0xe4), a
        ld sp,#0x10f0
        ei
        ld bc,#0x0100	// nastaveni load device CMT    
        exx
        ld hl,#0x1102	// header SIZE
        jp 0xecfc	// spust to z ROM
    2$:
        nop
    __endasm;
}

void main ( void ) {

    long st;
    unsigned int i = 0xffff;

    rUCMD = 0x71;	// vypnout USARTshell

/*
 * Tohle neni potreba posilat, protoze se jedna o implicitni hodnoty.
 * 
    rUCMD = 0x72;	// rychlost portu 115 200 bps
    rUDATA = 0x00;
    rUDATA = 0xc2;
    rUDATA = 0x01;
    rUDATA = 0x00;
    
    rSIO1 = 0x09;	// zapnout RTS rizeni toku
    rSIO1 = 0x01;

    rSIO1 = 0x0a;	// zapnout CTS rizeni toku
    rSIO1 = 0x01;
    
    rSIO1 = 0x04;	// zakazat interrupty
*/

    st = xmodemReceive ( (unsigned char *) 0x1180, 0xce80 );	// ukladat na 0x1180, max. do 0xdfff (52 864 bajtu)   

    rUCMD = 0x70;       // po prenosu znova zapnout USARTshell
    
    // Error ?
    if ( st < 0 ) {
        unsigned char err = (unsigned char) ~st;
        rBCOL = err;
        while ( 1 ) {};
    };
    
    // Kdo doposud neutrpel epilepticky sok, tak jej dostane po uspesnem prenosu ;)
    while ( i-- ) rBCOL = i&0xff;

    StartUpPrg();
}


